import java.awt.Font;

import sk.upjs.jpaz2.ImageTurtleShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;


public class ClockPane extends Pane {

    private long startTime;
    private Turtle painter;
    private Turtle backgroundPainter;
    
    public ClockPane() {
	resize(100, 40);
	setTransparentBackground(true);
	setBorderWidth(0);
	
	// Pripravime kreslicov (aby sme ich nemuseli zakazdym vytvarat a nastavovat)
	
	// Kreslic casu
	painter = new Turtle();
	add(painter);
	painter.setFont(new Font("Serif", Font.BOLD, 15));
	painter.setPosition(40, 23);
	painter.setDirection(90);
	painter.setVisible(false);
	
	// Kreslic pozadia
	backgroundPainter = new Turtle();
	add(backgroundPainter);
	backgroundPainter.center();
	backgroundPainter.setShape(new ImageTurtleShape("/images/timer.png"));
	backgroundPainter.setVisible(false);
    }
    
    public void start() {
	startTime = System.currentTimeMillis();
	setTickPeriod(100);	
    }
    
    public void stop() {
	setTickPeriod(0);
    }
    
    @Override
    protected void onTick() {
	int duration = (int)(System.currentTimeMillis() - startTime);
	clear();
	
	int seconds = duration / 1000;
	int secondFraction = (duration % 1000) / 100;
	String secondsString = seconds + "." + secondFraction;
	if (seconds < 10)
	    secondsString = "0" + secondsString;
	if (seconds < 100)
	    secondsString = "0" + secondsString;
	
	backgroundPainter.stamp();
	painter.print(secondsString);
    }
}
