import java.awt.event.*;

import sk.upjs.jpaz2.*;

public class RaceTrack extends Pane {

    // Auto
    private Car car;
    // Stopky
    private ClockPane clocks;

    public RaceTrack() {
	super(600, 600);
	makeGrass();

	// Vytvorime auto
	car = new Car();
	add(car);
	car.center();

	// Vytvorime stopky
	clocks = new ClockPane();
	add(clocks);
	clocks.setPosition(10, 10);
	clocks.start();

	// Nastavime volanie metody onTick s periodou 50ms
	setTickPeriod(50);

	// Nastavenie generovania opakovanych stlaceni klavesov pri zatlacenych klavesoch
	setKeyRepeatPeriod(KeyEvent.VK_LEFT, 60);
	setKeyRepeatPeriod(KeyEvent.VK_RIGHT, 60);
    }

    /**
     * Nakresli travnaty podklad
     */
    private void makeGrass() {
	Turtle painter = new Turtle();
	painter.setShape(new ImageTurtleShape("/images/grass.jpg"));
	add(painter);
	int tileSize = 204;
	int xTilesCount = 1 + getWidth() / tileSize;
	int yTilesCount = 1 + getHeight() / tileSize;
	for (int i = 0; i < xTilesCount; i++)
	    for (int j = 0; j < yTilesCount; j++) {
		painter.setPosition(tileSize / 2 + i * tileSize, tileSize / 2 + j * tileSize);
		painter.stamp();
	    }
	remove(painter);
    }

    @Override
    protected void onKeyPressed(KeyEvent e) {
	// Ovladanie
	if (e.getKeyCode() == KeyEvent.VK_LEFT) {
	    car.turn(-20);
	}
	if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
	    car.turn(20);
	}

	// Zrychlovanie a spomalovanie
	if (e.getKeyCode() == KeyEvent.VK_UP) {
	    car.setSpeed(car.getSpeed() + 0.1);
	}
	if (e.getKeyCode() == KeyEvent.VK_DOWN) {
	    car.setSpeed(car.getSpeed() - 0.1);
	}
    }
    
    @Override
    protected void onTick() {
	// Posunieme auto
	car.doMove();

	// Auto nepustime mimo plochu...
	if ((car.getX() < 0) || (car.getY() < 0) || (car.getX() > getWidth()) || (car.getY() > getHeight())) {
	    car.setSpeed(0);
	    clocks.start();
	}
    }
}
